import importlib
import logging

logger = logging.getLogger(__name__)

TASKS = ["remove_platform","install_drivers","install_cranium","unregister","debconf","install_os","get_registration_info","remount","install_database","install_platform","setup_os","remove_legacy_platform","nuke","afterinstall_checks","check_updates","remove_data","remove_user","register","update_platform","check_key","install_extras","setup_user","restore_backup","remove_old_repos","install_features","register_extra"]

class Task (object):
    def __init__ (self, name, module):
        self._name = name
        self._module = module

    def __call__ (self, *args, **kwargs):
        logger.info("Running task: {}".format(self._name))
        return self._module.__call__(*args, **kwargs)

for task_name in TASKS:
    vars()[task_name] = Task(task_name, importlib.import_module(".{}".format(task_name), package=__name__))
