import os
import logging

from ..context import Context

logger = logging.getLogger(__name__)

from ..registration import REPOS

def __call__ (config):
    context = Context(config, logger)
    needs_update = False
    
    for key, value in REPOS.iteritems():
        if key == "capturecast":
            continue
        
        extra_repo_apt_file = context.get_path(value["file"])
        if not os.path.isfile(extra_repo_apt_file):
            logger.info("Adding Cattura {} repository to apt".format(key))
            context.write_privileged("deb {} /".format(value["url"]), extra_repo_apt_file)
            needs_update = True
        else:
            logger.info("Not adding Cattura {} repository since it already exists".format(key))
    
    # update apt-get
    if needs_update:
        context.apt_update()